﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using LEAPI;

namespace LELanioSG_LIB_sampleCsharp
{
	class Program
	{
		static void Main()
		{
			while (true)
			{
				Console.WriteLine("1. LAN接続ゲートウェイを使用する");
				Console.WriteLine("2. USB接続ゲートウェイを使用する");
				Console.WriteLine("3. 通信タイムアウト時間を変更する");
				Console.WriteLine("4. 終了");
				Console.Write("選択してください : ");
				string choice = Console.ReadLine();
				if( choice == "4" )
				{
					Console.WriteLine("終了します");
					break;
				}
				if (choice == "1")
				{
					Console.Write("接続先アドレスを入力してください : ");
					string addr = Console.ReadLine();
					Console.Write("接続先ポート番号を入力してください : ");
					string input = Console.ReadLine();
					int port;
					if (!int.TryParse(input, out port))
					{
						Console.WriteLine("不正な入力です。");
						continue;
					}
					if (LELanioSG.StartLAN(addr, port) == 1)
					{
						GWconnected();
						LELanioSG.End();
					} else {
						Console.WriteLine("エラー: " + LELanioSG.GetLastError());
					}
					continue;
				}
				if (choice == "2")
				{
					Console.Write("接続先COMポート番号を入力してください : ");
					string input = Console.ReadLine();
					int com;
					if (!int.TryParse(input, out com))
					{
						Console.WriteLine("不正な入力です。");
						continue;
					}
					if (LELanioSG.StartUSB(com) == 1)
					{
						GWconnected();
						LELanioSG.End();
					}
					else
					{
						Console.WriteLine("エラー: " + LELanioSG.GetLastError());
					}
					continue;
				}
				if (choice == "3")
				{
					Console.Write("タイムアウト時間を入力してください(5-120 sec) : ");
					string input = Console.ReadLine();
					int sec;
					if (!int.TryParse(input, out sec))
					{
						Console.WriteLine("不正な入力です。");
						continue;
					}
					if (LELanioSG.SetTimeout(sec) == 1)
					{
						Console.WriteLine("変更しました。");
					} else {
						Console.WriteLine("エラー: " + LELanioSG.GetLastError());
					}
					continue;
				}
				Console.WriteLine("入力エラー");
			}
		}
		unsafe static void GWconnected()
		{
			int g_node = 0;
			while (true)
			{
				Console.WriteLine("現在の通信ノード先 : " + g_node);
				Console.WriteLine("1. 通信ノード先の変更");
				Console.WriteLine("2. デジタル出力");
				Console.WriteLine("3. デジタル出力状態の取得");
				Console.WriteLine("4. デジタル入力");
				Console.WriteLine("5. アナログ入力");
				Console.WriteLine("6. 終了");
				Console.Write("選択してください : ");
				string choice = Console.ReadLine();
				if (choice == "6")
				{
					Console.WriteLine("終了します");
					break;
				}
				if( choice == "1" )
				{
					Console.Write("通信先ノード番号を入力してください : ");
					string node = Console.ReadLine();
					g_node = int.Parse(node);
					continue;
				}
				if( choice == "2" )
				{
					Console.Write("DO出力を10進数数字で入力してください（LSBからDO1、DO2…） : ");
					string signal = Console.ReadLine();
					if (LELanioSG.DOall(g_node, int.Parse(signal)) == 1)
					{
						Console.WriteLine("実行しました。");
					} else {
						Console.WriteLine("エラー : " + LELanioSG.GetLastError());
					}
					continue;
				}
				if( choice == "3" )
				{
					int signal = 0;
					if (LELanioSG.GetDOall(g_node, ref signal) == 1)
					{
						Console.WriteLine("現在のDO出力の10進数数字（LSBからDO1、DO2…） : " + signal);
					} else {
						Console.WriteLine("エラー : " + LELanioSG.GetLastError());
					}
					continue;
				}
				if( choice == "4" )
				{
					int signal = 0;
					if (LELanioSG.DIall(g_node, ref signal) == 1)
					{
						Console.WriteLine("現在のDIの10進数数字（LSBからDI1、DI2…） : " + signal);
					} else {
						Console.WriteLine("エラー : " + LELanioSG.GetLastError());
					}
					continue;
				}
				if( choice == "5" )
				{
					Console.Write("取得するAI番号を入力してください（AI1 = 0 / AI2 = 1 ...） : ");
					string AI = Console.ReadLine();
					int val = 0;

					if (LELanioSG.AI(g_node, int.Parse(AI), ref val) == 1)
					{
						Console.WriteLine("取得した値 : " + val);
					} else {
						Console.WriteLine("エラー : " + LELanioSG.GetLastError());
					}
					continue;
				}
			}
		}
	}
}
